.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include wsock32.inc
includelib wsock32.lib

DlgProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
msgTell proto lpHostent:DWORD

IDI_ICON    equ 100
IDD_DLG     equ 500
 IDC_EDIT1   equ 511
 IDC_EDIT2   equ 512

.data
AppName     db "Get Host",0
nosocks     db "Unable to start WinSock",0
netdown     db "Network subsystem failed",0
notfound    db "Host not found",0
tryagain    db "Data currently unavailable",0
norecover   db "Request refused",0
nodata      db "No data record",0
blocking    db "Blocking operation in progress",0
unknown     db "Unknown error occured",0
errbadinput db "Not a valid IP address or Hostname",0
nl          db 13,10,0

.data?
hInstance   HINSTANCE   ?
hWnd        HANDLE      ?
WSAData     WSADATA    <?>
input       db 256 dup (?)
iaddr       DWORD       ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke DialogBoxParam, hInstance,IDD_DLG,NULL,ADDR DlgProc,NULL
    invoke ExitProcess, eax

DlgProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
    .IF (eax==WM_COMMAND)
        mov eax,wParam
        mov edx,eax
        shr eax,16      ;eax = notification code
        and edx,0FFFFh  ;edx = ID
        .IF (eax==BN_CLICKED)
            .IF (edx==IDOK)
                invoke WSAStartup, 101h,ADDR WSAData
                or eax,eax
                jnz @sockerr
                invoke GetDlgItemText, hwnd,IDC_EDIT1,ADDR input,SIZEOF input
                or eax,eax
                jz @noinput

;;want to use async lookup!!
                invoke gethostbyname, ADDR input
                or eax,eax
                jnz @lookit

                invoke inet_addr, ADDR input
                cmp eax,INADDR_NONE
                je @badinput
                mov iaddr, eax
                invoke gethostbyaddr, ADDR iaddr,4,PF_INET
                or eax,eax
                jz @checkerr
              @lookit:
                ;eax points to the hostent struct (lpHostent)
                invoke msgTell, eax
                jmp @out

              @sockerr:
                invoke MessageBox, hwnd,ADDR nosocks,ADDR AppName,MB_ICONERROR or MB_OK
                jmp @out

              @badinput:
                invoke SendDlgItemMessage, hwnd,IDC_EDIT2,WM_SETTEXT,NULL,ADDR errbadinput
                invoke SendDlgItemMessage, hwnd,IDC_EDIT1,EM_SETSEL,0,-1
                jmp @again

              @noinput:
                invoke SendDlgItemMessage, hwnd,IDC_EDIT2,WM_SETTEXT,NULL,NULL

              @again:
                invoke GetDlgItem, hwnd,IDC_EDIT1
                invoke SetFocus, eax
                invoke MessageBeep, MB_ICONERROR
                jmp @out

              @checkerr:
                invoke MessageBeep, MB_ICONERROR
                invoke WSAGetLastError
                .IF (eax==WSAENETDOWN)
                    mov edx, OFFSET netdown
                .ELSEIF (eax==WSAHOST_NOT_FOUND)
                    mov edx, OFFSET notfound
                .ELSEIF (eax==WSATRY_AGAIN)
                    mov edx, OFFSET tryagain
                .ELSEIF (eax==WSANO_RECOVERY)
                    mov edx, OFFSET norecover
                .ELSEIF (eax==WSANO_DATA)
                    mov edx, OFFSET nodata
                .ELSEIF (eax==WSAEINPROGRESS)
                    mov edx, OFFSET blocking
                .ELSE
                    mov edx, OFFSET unknown
                .ENDIF
              @msgTell:
                invoke SendDlgItemMessage, hwnd,IDC_EDIT2,WM_SETTEXT,NULL,edx
              @out:
            .ELSEIF (edx==IDCANCEL)
                invoke SendMessage, hwnd,WM_CLOSE,NULL,NULL
            .ENDIF
        .ENDIF
    .ELSEIF (eax==WM_CLOSE)
        invoke EndDialog, hwnd,NULL
    .ELSEIF (eax==WM_INITDIALOG)
        mov eax,hwnd
        mov hWnd,eax
        invoke GetDlgItem, hwnd,IDC_EDIT1
        push eax
        invoke SendMessage, eax,EM_SETLIMITTEXT,(sizeof input)-1,NULL
        pop eax
        invoke SetFocus, eax
        xor eax,eax
        ret
    .ELSE
        xor eax,eax ;FALSE
        ret
    .ENDIF
    mov eax,TRUE
    ret
DlgProc endp

msgTell proc lpHostent:DWORD
    push esi
    push edi
    push ebx
    mov esi,lpHostent
    assume esi:ptr hostent
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_SETSEL,0,-1
    mov ebx,[esi].h_name
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_REPLACESEL,FALSE,ebx
    ;-- names --
    mov edi,[esi].h_alias
    test edi,edi
    jz @adds
  @@:
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_SETSEL,-1,-1
    mov ebx,[edi]
    test ebx,ebx
    jz @adds
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_REPLACESEL,FALSE,ADDR nl
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_REPLACESEL,FALSE,ebx
    add edi,4
    jmp @B
  @adds:
    ;-- ip addresses --
    mov edi,[esi].h_list
    test edi,edi
    jz @done
  @@:
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_SETSEL,-1,-1
    mov ebx,[edi]
    test ebx,ebx
    jz @done
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_REPLACESEL,FALSE,ADDR nl
    mov eax,[ebx]
    invoke inet_ntoa, eax
    invoke SendDlgItemMessage, hWnd,IDC_EDIT2,EM_REPLACESEL,FALSE,eax
    add edi,4
    jmp @B
  @done:
    pop ebx
    pop edi
    pop esi
    assume esi:nothing
    ret
msgTell endp

end start
